diff --git a/src/config/wazuh_db-config.c b/src/config/wazuh_db-config.c
index f50b84f4acf..3b419ddd39e 100644
--- a/src/config/wazuh_db-config.c
+++ b/src/config/wazuh_db-config.c
@@ -27,34 +27,36 @@ static short eval_bool(const char *str) {
     }
 }
 
-int Read_WazuhDB(const OS_XML *xml, XML_NODE chld_node) {
-    const char* xml_backup = "backup";
-    const char* xml_database = "database";
-    const char* xml_database_global = "global";
+int Read_WazuhDB(const OS_XML *xml, XML_NODE child_node) {
+    const char *xml_backup = "backup";
+    const char *xml_database = "database";
+    const char *xml_database_global = "global";
 
-    for(int i = 0; chld_node[i]; i++) {
-        if (!chld_node[i]->element) {
-            merror(XML_ELEMNULL);
-            return OS_INVALID;
-        } else if (!strcmp(chld_node[i]->element, xml_backup)) {
-            if(chld_node[i]->attributes && chld_node[i]->attributes[0] && !strcmp(chld_node[i]->attributes[0], xml_database)) {
-                if(chld_node[i]->values && chld_node[i]->values[0] && !strcmp(chld_node[i]->values[0], xml_database_global)) {
-                    return Read_WazuhDB_Backup(xml, chld_node[i], WDB_GLOBAL_BACKUP);
-                } else {
-                    merror(XML_VALUEERR, chld_node[i]->attributes[0], chld_node[i]->values && chld_node[i]->values[0] ? chld_node[i]->values[0] : "");
-                    return OS_INVALID;
-                }
-            } else {
-                merror(XML_INVATTR, chld_node[i]->attributes && chld_node[i]->attributes[0] ? chld_node[i]->attributes[0] : "", chld_node[i]->element);
-                return OS_INVALID;
-            }
-        } else {
-            merror(XML_INVELEM, chld_node[i]->element);
-            return OS_INVALID;
-        }
+    xml_node *node = *child_node;
+
+    if (node->element != NULL) {
+        merror(XML_ELEMNULL);
+        return OS_INVALID;
     }
 
-    return OS_SUCCESS;
+    if (strcmp(node->element, xml_backup) != 0) {
+        merror(XML_INVELEM, node->element);
+        return OS_INVALID;
+    }
+
+    char **attr = node->attributes;
+    if (attr == NULL || attr[0] == NULL || strcmp(attr[0], xml_database) != 0) {
+        merror(XML_INVATTR, attr && attr[0] ? attr[0] : "", node->element);
+        return OS_INVALID;
+    }
+
+    char **val = node->values;
+    if (val == NULL || val[0] == NULL || strcmp(val[0], xml_database_global) != 0) {
+        merror(XML_VALUEERR, node->attributes[0], val && val[0] ? val[0] : "");
+        return OS_INVALID;
+    }
+
+    return Read_WazuhDB_Backup(xml, node, WDB_GLOBAL_BACKUP);
 }
 
 int Read_WazuhDB_Backup(const OS_XML *xml, xml_node * node, int const BACKUP_NODE) {
diff --git a/src/os_crypto/sha1/sha1_op.h b/src/os_crypto/sha1/sha1_op.h
index 8c348d2084a..af8eebdb0a3 100644
--- a/src/os_crypto/sha1/sha1_op.h
+++ b/src/os_crypto/sha1/sha1_op.h
@@ -17,7 +17,9 @@
 #include <windef.h>
 #endif
 
-typedef char os_sha1[41];
+#define OS_SHA1_HEXDIGEST_SIZE (SHA_DIGEST_LENGTH * 2) // Sha1 digest len (20) * 2 (hex chars per byte)
+
+typedef char os_sha1[OS_SHA1_HEXDIGEST_SIZE + 1];
 
 int OS_SHA1_File(const char *fname, os_sha1 output, int mode) __attribute((nonnull));
 int OS_SHA1_Str(const char *str, ssize_t length, os_sha1 output) __attribute((nonnull));
diff --git a/src/wazuh_db/helpers/wdb_global_helpers.c b/src/wazuh_db/helpers/wdb_global_helpers.c
index 0c0a6fc6bb7..e18408648cb 100644
--- a/src/wazuh_db/helpers/wdb_global_helpers.c
+++ b/src/wazuh_db/helpers/wdb_global_helpers.c
@@ -1122,17 +1122,23 @@ int wdb_create_agent_db(int id, const char *name) {
     }
 
     snprintf(src_path, OS_FLSIZE, "%s/%s", WDB_DIR, WDB_PROF_NAME);
-    if (OS_SUCCESS != stat(src_path, &st_buffer)) {
+    if (source = fopen(src_path, "r"), source == NULL) {
+        if (errno != EACCES) // If we get any other error other that 'file does not exits'
+        {
+            merror("Error accessing file (%s): (%s)", src_path, strerror(errno));
+            return OS_INVALID;
+        }
+
         mdebug1("Profile database not found, creating.");
 
         if (wdb_create_profile(src_path) < 0) {
             return OS_INVALID;
         }
-    }
 
-    if (!(source = fopen(src_path, "r"))) {
-        merror("Couldn't open profile '%s'.", src_path);
-        return OS_INVALID;
+        if (!(source = fopen(src_path, "r"))) {
+            merror("Couldn't open profile '%s'.", src_path);
+            return OS_INVALID;
+        }
     }
 
     if (!(dest = fopen(dst_path, "w"))) {
diff --git a/src/wazuh_db/wdb_global.c b/src/wazuh_db/wdb_global.c
index 4e1c1eb4ce6..8ca1e203249 100644
--- a/src/wazuh_db/wdb_global.c
+++ b/src/wazuh_db/wdb_global.c
@@ -1857,9 +1857,15 @@ int wdb_global_restore_backup(wdb_t** wdb, char* snapshot, bool save_pre_restore
             *wdb = NULL;
 
             unlink(global_path);
-            rename(global_tmp_path, global_path);
-            snprintf(output, OS_MAXSTR + 1, "ok");
-            result = OS_SUCCESS;
+
+            if (rename(global_tmp_path, global_path) != OS_SUCCESS) {
+                merror("Renaming %s to %s: %s", global_tmp_path, global_path, strerror(errno));
+                result = OS_INVALID;
+            }
+            else {
+                snprintf(output, OS_MAXSTR + 1, "ok");
+                result = OS_SUCCESS;
+            }
         } else {
             mdebug1("Failed during backup decompression");
             snprintf(output, OS_MAXSTR + 1, "err Failed during backup decompression");
diff --git a/src/wazuh_db/wdb_parser.c b/src/wazuh_db/wdb_parser.c
index ac09cd78fb5..d61bc346402 100644
--- a/src/wazuh_db/wdb_parser.c
+++ b/src/wazuh_db/wdb_parser.c
@@ -5470,22 +5470,26 @@ int wdb_parse_global_sync_agent_info_set(wdb_t * wdb, char * input, char * outpu
 }
 
 int wdb_parse_get_groups_integrity(wdb_t* wdb, char* input, char* output) {
+    if(strlen(input) < OS_SHA1_HEXDIGEST_SIZE){
+        merror("Error trying to get the hash hex-digest");
+        return OS_INVALID;
+    }
+
     os_sha1 hash = {0};
-    strncpy(hash, input, strlen(input));
-    int ret = OS_SUCCESS;
+    strncpy(hash, input, OS_SHA1_HEXDIGEST_SIZE);
+
     cJSON *j_result = wdb_global_get_groups_integrity(wdb, hash);
-    if (j_result) {
-        char* out = cJSON_PrintUnformatted(j_result);
-        snprintf(output, OS_MAXSTR + 1, "ok %s", out);
-        os_free(out);
-        cJSON_Delete(j_result);
-    } else {
+    if (j_result == NULL) {
         mdebug1("Error getting groups integrity information from global.db.");
         snprintf(output, OS_MAXSTR + 1, "err Error getting groups integrity information from global.db.");
-        ret = OS_INVALID;
+        return OS_INVALID;
     }
 
-    return ret;
+    char* out = cJSON_PrintUnformatted(j_result);
+    snprintf(output, OS_MAXSTR + 1, "ok %s", out);
+    os_free(out);
+    cJSON_Delete(j_result);
+    return OS_SUCCESS;
 }
 
 int wdb_parse_global_get_agent_info(wdb_t* wdb, char* input, char* output) {
